function solution = lib_least_squares_fit(start, stop, y, degree, N)

% Function refitting a given segment of the signal by the ordinary least
% squares method, prosucining new parameters
%
% INPUT:
% start - segment start position in signal 
% stop - segment stop position in signal 
% y - observed signal - (column) vector of data
% degree - polynom degree
% N - lenght of signal y
%
% OUTPUT: 
% solution ... M parameters minimizing square error ... [x0,x1, ... xM],
% number of parameres is given by degree
% -----------------------------------------------------------------------
Npom = stop-start+1; % lenght of segment

A = zeros (Npom,degree);
for i=1:degree
    startstopvector = ([start:stop]./N).^(i-1)';
    A(:,i)=startstopvector;
end

solution=A\y; % new parameters

