function y = lib_recon_from_params(x, N, degree)

% Function that reconstructs the signal from the parameters
%
% INPUT
% x - parameters coefficients
% N - length of reconstructing signal
% degree - polynom degree
%
% OUTPUT:
% y - reconstructed signal from input parameters
% ------------------------------------------------------------------------

parameterization_coeff=reshape(x,N,degree);

matrix_of_d=ones(N,degree);
d = ((1:N)/N)';  %linearly growing
for i=1:degree
    matrix_of_d(:,i)=d.^(i-1);
end

y=sum(parameterization_coeff.*matrix_of_d,2); %synthesize the estimated signal
